/* Datei: fkt_ptr.c */
#include <stdio.h>
#include <time.h>
#include <math.h>

void f1 (void)
{
   printf ("Druecken Sie bitte Enter:");
   getchar();
}

/* Pointer auf eine Funktion als Uebergabeparameter */
double eval_time (void (*ptr)(void))
/* nach dem Standard ist double eval_time (void ptr (void)) */
/* hierzu aequivalent                                       */
{
   time_t begin, end;
   begin = time (NULL);
   (*ptr)();         /* Hier wird eine Funktion aufgerufen, */
                     /* die an der Adresse ptr beginnt      */ 
                     /* aequivalent hierzu ist: ptr();      */
   end = time (NULL);
   return difftime (end, begin);
}

int main (void)
{
   printf ("Zeit bis Enter gedrueckt wurde: %3.0f sec\n\n",
      eval_time (f1));
   printf ("Zeit bis Enter gedrueckt wurde: %3.0f sec\n\n",
      eval_time (f1));
   return 0;
}



