/* Datei: qsort.c */
#include <stdio.h>
#include <stdlib.h>
int vergleicheZweiInts (const void * elem1, const void * elem2)
{
   int ret, i1, i2;
   i1 = *(int *) elem1; /* cast auf int *                     (1) */
   i2 = *(int *) elem2; /* cast auf int *                         */
   if (i1 < i2)
   {
      ret = -1;
   }   /* Rueckgabe -1, wenn Element 1 kleiner      (2) */
   else if (i1 == i2)
   {
	  ret = 0;
   }    /* Rueckgabe 0 bei Gleichheit                (3) */
   else 
   {
	  ret = 1;
   }    /* Rueckgabe 1, wenn Element 1 groesser      (4) */ 
   
   return ret;
}

int main (void)
{
   /* Anlegen eines Test-Arrays mit int-Zahlen                (5) */
   int array []= {5, 3, 9, 20, 1, 3, 7, 18, 21, 0};
   /* Anzahl Elemente im Array                                (6) */
   size_t len = sizeof (array) / sizeof (int); 
   unsigned int index;
   /* Ausgabe des unsortierten Arrays                             */
   printf ("\nUnsortiertes Array:\t");
   for (index = 0; index < len; index++)
   {
      printf ("%2d ", array[index]);
   }
   /* Array mit qsort() sortieren                             (7) */
   qsort ((void *)array, len, sizeof (int), vergleicheZweiInts);
   /* Ausgabe des sortierten Arrays                               */
   printf ("\nSortiertes Array:\t");
   for (index = 0; index < len; index++)
   {
      printf ("%2d ", array[index]);
   }
   printf ("\n");
   return 0;
}




