/* Datei: generic.c */
#include <math.h>
#include <complex.h>

#define sinus (X) _Generic ((X),                       \
                           default: sin,              \
                           long double: sinl,         \
                           float: sinf,               \
                           double complex: csin,      \
                           float complex: csinf,      \
                           long double complex: csinl \
                           ) (X)

int main (int argc, char * argv[])
{
    int i = 4;
    float f = 1.2f;
    double d = 3.2;
    double complex dc = 2.0 + 3.0 * I;

    sinus (d); // ruft Defaultwert sin(d) auf
    sinus (dc); // ruft csin(dc) auf
    sinus (f); // ruft sinf(f) auf
    sinus (i); // ruft Defaultwert sin(i) auf

    return 0;
}

