/* Datei: mythread2.c */
#include <stdio.h>
#include <stdbool.h>
#include <threads.h>

static int beenden = false;

int tfunction (void * targ)
{
   /* Parameter wird hier nicht verwendet */
   (void) targ;

   /* Thread initialisieren */
   int i = 0;

   /* Thread zyklisch ausfuehren */
   while (true) 
   {
      printf ("Laufvariable = %i\n", i++);
		
      /* abfragen, ob Thread beendet werden soll */
      if (true == beenden) 
      {
         break;
      }
   }
   return thrd_success;
}

int main (void) 
{
   /* Variable zum Speichern der Thread ID */
   thrd_t thread;

   /* Thread erzeugen und ausfuehren */
   thrd_create (&thread, tfunction, NULL);

   /* Programm abarbeiten */
   for (int i = 0; i < 1e8; i++) 
   {
      printf ("Warten = %i\n", i);
   }

   /* globale Variable fuer Thread-Abbruch auf true setzen     */
   /* und bis zum Beenden der Threads warten                   */
   beenden = true;
   thrd_join (thread, NULL);
}