/* Datei: fehler.c */
#include <stdio.h>

/* fehlertext: liefert Text der entsprechenden Fehler-Nr. n */
const char * fehlertext (int n);

int main (void)
{
   int fehlernummer;
   printf ("Geben Sie bitte eine Fehlernummer von 1 bis 6 ein: ");
   scanf ("%d", &fehlernummer); 
   printf ("\nText zu Fehler %d: %s\n", 
      fehlernummer, fehlertext (fehlernummer));
   return 0;
}

const char * fehlertext (int n)
{
   /* Initialisierung der Fehlertexte */
   static const char * err_desc[] = {
      "kein Fehler",
      "Fehlertext 1",      "Fehlertext 2",
      "Fehlertext 3",      "Fehlertext 4",
      "Fehlertext 5",      "Fehlertext 6" };

      return (n < 0 || n > 6) ? "Fehlercode existiert nicht" : 
             err_desc[n];
}



