/* Datei: union.c */
#include <stdio.h>

int main (void)
{
   union zahl 
   { 
      int   intnam;
      long  longnam;
      float floatnam;
   };

   union zahl feld [2], * ptr;
   float * floatptr;
   
   /* Groesse einer Union und ihrer Alternativen                  */
   printf ("\nGroesse der Union: %d", sizeof (union zahl));
   printf ("\nGroesse der Array-Komponenten: %d", sizeof (feld[1]));
   printf ("\nGroesse von int  : %d", sizeof (int));
   printf ("\nGroesse von long : %d", sizeof (long));
   printf ("\nGroesse von float: %d\n", sizeof (float));

   feld[0].longnam = 5L;
   printf ("\nInhalt von feld[0]: %ld", feld[0].longnam);
   feld[0].intnam = 10;
   printf ("\nInhalt von feld[0]: %d", feld[0].intnam);
   feld[0].floatnam = 100.0;
   printf ("\nInhalt von feld[0]: %6.2f", feld[0].floatnam);
   printf ("\n-------------------------------------");

   feld[1] = feld[0];             /* Zuweisung einer Union        */
   printf ("\nInhalt von feld[1]: %6.2f", feld[1].floatnam);
   feld[1].floatnam += 25.;
   ptr = &feld[1];                /* Adresse einer Union          */
   /* Umwandlung Zeiger auf Union in Zeiger auf Alternative       */
   floatptr = (float *) ptr;


   printf ("\nInhalt von feld[1]: %6.2f",
            ptr -> floatnam);               /* Inhalt Alternative */
   printf ("\nInhalt von feld[1]: %6.2f",
            *floatptr);                     /* Inhalt Alternative */
   printf ("\ndas war's\n\n\n");

   return 0;
}




