/* Datei: auswahl.c (Sortieren durch Auswaehlen fuer ein Array  */
/* i mit Komponenten i[0] bis i[anzahl-1] vom Typ int)          */
#include <stdio.h>
int main(void)
{
   /* Definition und Initialisierung des Arrays:                */
   int i[] = {7, 3, 8, 6, 9, 4};
   const int anzahl = sizeof i / sizeof i[0];
   /* Feld wird an Position zahl geteilt:                       */
   /* linkes Teilfeld am Anfang leer, dann zunehmend            */
   /* sortiert, rechtes Teilfeld unsortiert                     */

   int zahl;
   /* sort speichert kleinstes Element aus rechtem Teilfeld,    */
   /* min den Index dazu */
   int sort, min;
   /* pos ist Laufvariable fuer rechtes Teilfeld                */
   int pos;
    /* Ausgabe des unsortierten Arrays                          */
   printf ("Unsortiertes Array:       ");
   for (zahl = 0; zahl < anzahl; zahl++)
      printf ("%i, ", i[zahl]);
   printf ("\n");
   /* Feld an Position zahl teilen. Das Verfahren beginnt       */
   /* mit einer linken leeren Teilliste                         */
   for (zahl = 0; zahl < anzahl - 1; zahl++)
   {
      /* Element zahl koennte vielleicht das Minimum            */
      /* der rechten Teilliste sein                             */
      min = zahl;
      sort = i[zahl];
      /* Kleinstes Element und dessen Index im rechten,         */
      /* unsortierten Teilfeld suchen                           */
      for (pos = zahl + 1; pos < anzahl; pos++)
         if (sort > i[pos])
         {
            /* Kleineres Element gefunden. Es wird das          */
            /* neue Minimum fuer die weiteren Vergleiche        */
            min = pos;
            sort = i[pos];
         }
      /* Austauschen des gefundenen kleinsten Elementes         */
      /* mit dem Element am Anfang der rechten                  */
      /* unsortierten Teilliste                                 */
      i[min] = i[zahl];
      i[zahl] = sort;
      /* Ausgabe des Arrays nach Vertauschung                   */
      printf ("Arbeitsschritt: %i  Array: ", zahl + 1);
      for (min = 0; min < anzahl; min++)
         printf ("%i, ", i[min]);
      printf ("\n");
   }
   return 0;
}




